/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of CaseResampling.xs. Do not edit this file, edit CaseResampling.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CaseResampling.xs"
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "mt.h"
#include "stats.h"
#include <stdlib.h>


typedef struct mt * Statistics__CaseResampling__RdGen;

void*
U32ArrayPtr (pTHX_ int n)
{
  SV * sv = sv_2mortal( NEWSV( 0, n*sizeof(U32) ) );
  return SvPVX(sv);
}

double
cs_mean_av(pTHX_ AV* sample)
{
  I32 i, n;
  SV** elem;
  double sum;
  n = av_len(sample)+1;
  sum = 0.;
  for (i = 0; i < n; ++i) {
    if (NULL == (elem = av_fetch(sample, i, 0))) {
      croak("Could not fetch element from array");
    }
    else
      sum += SvNV(*elem);
  }
  return sum/(double)n;
}

double
cs_sum_deviation_squared_av(pTHX_ double mean, AV* sample)
{
  I32 i, n;
  SV** elem;
  double sum;
  n = av_len(sample)+1;
  sum = 0.;
  for (i = 0; i < n; ++i) {
    if (NULL == (elem = av_fetch(sample, i, 0))) {
      croak("Could not fetch element from array");
    }
    else
      sum += pow(SvNV(*elem)-mean, 2);
  }
  return sum;
}

void
avToCAry(pTHX_ AV* in, double** out, I32* n)
{
  I32 thisN;
  double* ary;
  SV** elem;
  I32 i;
  thisN = av_len(in)+1;
  *n = thisN;
  if (thisN == 0)
    return;

  Newx(ary, thisN, double);
  *out = ary;
  for (i = 0; i < thisN; ++i) {
    if (NULL == (elem = av_fetch(in, i, 0))) {
      Safefree(ary);
      croak("Could not fetch element from array");
    }
    else
      ary[i] = SvNV(*elem);
  }
}

void
cAryToAV(pTHX_ double* in, AV** out, I32 n)
{
  SV* elem;
  I32 i;
  *out = newAV();
  if (n == 0)
    return;

  av_extend(*out, n-1);

  for (i = 0; i < n; ++i) {
    elem = newSVnv(in[i]);
    if (NULL == av_store(*out, i, elem))
      SvREFCNT_dec(elem);
  }
}

struct mt*
get_rnd(pTHX)
{
  IV tmp;
  SV* therndsv = get_sv("Statistics::CaseResampling::Rnd", 0);
  if (therndsv == NULL
      || !SvROK(therndsv)
      || !sv_derived_from(therndsv, "Statistics::CaseResampling::RdGen"))
  {
    croak("Random number generator not set up!");
  }
  tmp = SvIV((SV*)SvRV(therndsv));
  return INT2PTR(struct mt*, tmp);
}


#line 126 "CaseResampling.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 270 "CaseResampling.c"

/* INCLUDE:  Including 'RdGen.xs.inc' from 'CaseResampling.xs' */


XS_EUPXS(XS_Statistics__CaseResampling__RdGen_setup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling__RdGen_setup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seed");
    {
	U32	seed = (unsigned long)SvUV(ST(0))
;
	Statistics__CaseResampling__RdGen	RETVAL;
#line 9 "./RdGen.xs.inc"
    RETVAL = mt_setup(seed);
#line 287 "CaseResampling.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Statistics::CaseResampling::RdGen", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling__RdGen_setup_array); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling__RdGen_setup_array)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "array, ...");
    {
	Statistics__CaseResampling__RdGen	RETVAL;
#line 16 "./RdGen.xs.inc"
    U32 * array = U32ArrayPtr(aTHX_ items);
    U32 ix_array = 0;
    while (items--) {
      array[ix_array] = (U32)SvIV(ST(ix_array));
      ix_array++;
    }
    RETVAL = mt_setup_array( (uint32_t*)array, ix_array );
#line 315 "CaseResampling.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Statistics::CaseResampling::RdGen", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling__RdGen_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling__RdGen_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Statistics__CaseResampling__RdGen	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Statistics__CaseResampling__RdGen,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Statistics::CaseResampling::RdGen::DESTROY",
			"self")
;
#line 30 "./RdGen.xs.inc"
    mt_free(self);
#line 347 "CaseResampling.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Statistics__CaseResampling__RdGen_genrand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling__RdGen_genrand)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Statistics__CaseResampling__RdGen	self;
	double	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Statistics::CaseResampling::RdGen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Statistics__CaseResampling__RdGen,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Statistics::CaseResampling::RdGen::genrand",
			"self", "Statistics::CaseResampling::RdGen",
			refstr, ST(0)
		);
	}
;
#line 36 "./RdGen.xs.inc"
    RETVAL = mt_genrand(self);
#line 379 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CaseResampling.xs' from 'RdGen.xs.inc' */


XS_EUPXS(XS_Statistics__CaseResampling_resample); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_resample)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
#line 128 "CaseResampling.xs"
    I32 nelem;
    double* csample;
    double* destsample;
    struct mt* rnd;
#line 403 "CaseResampling.c"
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::resample",
				"sample");
		}
	} STMT_END
;
#line 133 "CaseResampling.xs"
    rnd = get_rnd(aTHX);
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem != 0) {
      Newx(destsample, nelem, double);
      do_resample(csample, nelem, rnd, destsample);
      cAryToAV(aTHX_ destsample, &RETVAL, nelem);
      Safefree(destsample);
    }
    else
      RETVAL = newAV();
    Safefree(csample);
    sv_2mortal((SV*)RETVAL);
#line 432 "CaseResampling.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_resample_medians); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_resample_medians)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sample, runs");
    {
	AV*	sample;
	I32	runs = (I32)SvIV(ST(1))
;
#line 153 "CaseResampling.xs"
    I32 nelem;
    I32 i_run;
    double* csample;
    double* destsample;
    struct mt* rnd;
#line 460 "CaseResampling.c"
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::resample_medians",
				"sample");
		}
	} STMT_END
;
#line 159 "CaseResampling.xs"
    rnd = get_rnd(aTHX);
    avToCAry(aTHX_ sample, &csample, &nelem);
    RETVAL = newAV();
    if (nelem != 0) {
      Newx(destsample, nelem, double);
      av_extend(RETVAL, runs-1);
      for (i_run = 0; i_run < runs; ++i_run) {
        do_resample(csample, nelem, rnd, destsample);
        av_store(RETVAL, i_run, newSVnv(cs_median(destsample, nelem)));
      }
      Safefree(destsample);
    }
    Safefree(csample);
    sv_2mortal((SV*)RETVAL);
#line 491 "CaseResampling.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_resample_means); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_resample_means)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sample, runs");
    {
	AV*	sample;
	I32	runs = (I32)SvIV(ST(1))
;
#line 181 "CaseResampling.xs"
    I32 nelem;
    I32 i_run;
    double* csample;
    double* destsample;
    struct mt* rnd;
#line 519 "CaseResampling.c"
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::resample_means",
				"sample");
		}
	} STMT_END
;
#line 187 "CaseResampling.xs"
    rnd = get_rnd(aTHX);
    avToCAry(aTHX_ sample, &csample, &nelem);
    RETVAL = newAV();
    if (nelem != 0) {
      Newx(destsample, nelem, double);
      av_extend(RETVAL, runs-1);
      for (i_run = 0; i_run < runs; ++i_run) {
        do_resample(csample, nelem, rnd, destsample);
        av_store(RETVAL, i_run, newSVnv(cs_mean(destsample, nelem)));
      }
      Safefree(destsample);
    }
    Safefree(csample);
    sv_2mortal((SV*)RETVAL);
#line 550 "CaseResampling.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_median); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_median)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
#line 208 "CaseResampling.xs"
    I32 nelem;
    double* csample;
#line 573 "CaseResampling.c"
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::median",
				"sample");
		}
	} STMT_END
;
#line 211 "CaseResampling.xs"
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem == 0)
      RETVAL = 0.;
    else
      RETVAL = cs_median(csample, nelem);
    Safefree(csample);
#line 597 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_median_absolute_deviation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_median_absolute_deviation)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
#line 223 "CaseResampling.xs"
    I32 nelem;
    double* csample;
#line 616 "CaseResampling.c"
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::median_absolute_deviation",
				"sample");
		}
	} STMT_END
;
#line 226 "CaseResampling.xs"
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem == 0)
      RETVAL = 0.;
    else {
      unsigned int i;
      double* absdev;

      const double median = cs_median(csample, nelem);
      /* in principle, I think one could write an algorithm
       * that doesn't require mallocing the second array by inlining an
       * O(n) median that visits each element only once? */
      absdev = (double*)malloc(nelem * sizeof(double));
      for (i = 0; i < nelem; ++i)
        absdev[i] = fabs(csample[i] - median);
      RETVAL = cs_median(absdev, nelem);
      free(absdev);
    }
    Safefree(csample);
#line 652 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_first_quartile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_first_quartile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
#line 251 "CaseResampling.xs"
    I32 nelem;
    double* csample;
#line 671 "CaseResampling.c"
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::first_quartile",
				"sample");
		}
	} STMT_END
;
#line 254 "CaseResampling.xs"
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem == 0)
      RETVAL = 0.;
    else
      RETVAL = cs_first_quartile(csample, nelem);
    Safefree(csample);
#line 695 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_third_quartile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_third_quartile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
#line 267 "CaseResampling.xs"
    I32 nelem;
    double* csample;
#line 714 "CaseResampling.c"
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::third_quartile",
				"sample");
		}
	} STMT_END
;
#line 270 "CaseResampling.xs"
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem == 0)
      RETVAL = 0.;
    else
      RETVAL = cs_third_quartile(csample, nelem);
    Safefree(csample);
#line 738 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_mean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_mean)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sample");
    {
	AV*	sample;
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::mean",
				"sample");
		}
	} STMT_END
;
#line 283 "CaseResampling.xs"
    RETVAL = cs_mean_av(aTHX_ sample);
#line 772 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_sample_standard_deviation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_sample_standard_deviation)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "mean, sample");
    {
	SV*	mean = ST(0)
;
	AV*	sample;
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::sample_standard_deviation",
				"sample");
		}
	} STMT_END
;
#line 292 "CaseResampling.xs"
    RETVAL =  cs_sum_deviation_squared_av(aTHX_ SvNV(mean), sample);
    RETVAL = pow( RETVAL / av_len(sample), 0.5 ); /* av_len() is N-1! */
#line 809 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_population_standard_deviation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_population_standard_deviation)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "mean, sample");
    {
	SV*	mean = ST(0)
;
	AV*	sample;
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::population_standard_deviation",
				"sample");
		}
	} STMT_END
;
#line 302 "CaseResampling.xs"
    RETVAL =  cs_sum_deviation_squared_av(aTHX_ SvNV(mean), sample);
    RETVAL = pow( RETVAL / (av_len(sample)+1), 0.5 ); /* av_len() is N-1! */
#line 846 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_select_kth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_select_kth)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sample, kth");
    {
	AV*	sample;
	I32	kth = (I32)SvIV(ST(1))
;
#line 312 "CaseResampling.xs"
    I32 nelem;
    double* csample;
#line 867 "CaseResampling.c"
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::select_kth",
				"sample");
		}
	} STMT_END
;
#line 315 "CaseResampling.xs"
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (kth < 1 || kth > nelem) {
      croak("Can't select %ith smallest element from a list of %i elements", kth, nelem);
    }
    RETVAL = cs_select(csample, nelem, kth-1);
    Safefree(csample);
#line 891 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_median_simple_confidence_limits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_median_simple_confidence_limits)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "sample, confidence, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	AV*	sample;
	double	confidence = (double)SvNV(ST(1))
;
#line 329 "CaseResampling.xs"
    /* "confidence" is 1-alpha */
    I32 runs, nelem, i_run;
    double *csample, *destsample, *medians;
    struct mt* rnd;
    double median   = 0.;
    double lower_ci = 0.;
    double upper_ci = 0.;
    double alpha;
#line 920 "CaseResampling.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::median_simple_confidence_limits",
				"sample");
		}
	} STMT_END
;
#line 338 "CaseResampling.xs"
    alpha = 1.-confidence;
#line 937 "CaseResampling.c"
#line 340 "CaseResampling.xs"
    if (items == 2)
      runs = 1000;
    else if (items == 3)
      runs = SvUV(ST(2));
    else {
      croak("Usage: ($lower, $median, $upper) = median_confidence_limits(\\@sample, $confidence, [$nruns]);");
    }
    if (confidence <= 0. || confidence >= 1.) {
      croak("Confidence level has to be in (0, 1)");
    }
    rnd = get_rnd(aTHX);
    avToCAry(aTHX_ sample, &csample, &nelem);
    if (nelem != 0) {
      median = cs_median(csample, nelem);
      Newx(medians, runs, double);
      Newx(destsample, nelem, double);
      for (i_run = 0; i_run < runs; ++i_run) {
        do_resample(csample, nelem, rnd, destsample);
        medians[i_run] = cs_median(destsample, nelem);
      }
      Safefree(destsample);
      /* lower = t - (t*_((R+1)*(1-alpha)) - t)
       * upper = t - (t*_((R+1)*alpha) - t)
       */
      lower_ci = 2.*median - cs_select( medians, runs, (I32)((runs+1.)*(1.-alpha)) );
      upper_ci = 2.*median - cs_select( medians, runs, (I32)((runs+1.)*alpha) );
      Safefree(medians);
    }
    Safefree(csample);
    EXTEND(SP, 3);
    mPUSHn(lower_ci);
    mPUSHn(median);
    mPUSHn(upper_ci);
#line 972 "CaseResampling.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Statistics__CaseResampling_simple_confidence_limits_from_samples); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_simple_confidence_limits_from_samples)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "statistic, statistics, confidence");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	double	statistic = (double)SvNV(ST(0))
;
	AV*	statistics;
	double	confidence = (double)SvNV(ST(2))
;
#line 381 "CaseResampling.xs"
    /* "confidence" is 1-alpha */
    I32 nelem;
    double *cstatistics;
    double lower_ci = 0.;
    double upper_ci = 0.;
    double alpha;
#line 1000 "CaseResampling.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    statistics = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Statistics::CaseResampling::simple_confidence_limits_from_samples",
				"statistics");
		}
	} STMT_END
;
#line 388 "CaseResampling.xs"
    alpha = 1.-confidence;
#line 1017 "CaseResampling.c"
#line 390 "CaseResampling.xs"
    if (confidence <= 0. || confidence >= 1.) {
      croak("Confidence level has to be in (0, 1)");
    }
    avToCAry(aTHX_ statistics, &cstatistics, &nelem);
    if (nelem != 0) {
      /* lower = t - (t*_((R+1)*(1-alpha)) - t)
       * upper = t - (t*_((R+1)*alpha) - t)
       */
      lower_ci = 2.*statistic - cs_select( cstatistics, nelem, (I32)((nelem+1.)*(1.-alpha)) );
      upper_ci = 2.*statistic - cs_select( cstatistics, nelem, (I32)((nelem+1.)*alpha) );
    }
    Safefree(cstatistics);
    EXTEND(SP, 3);
    mPUSHn(lower_ci);
    mPUSHn(statistic);
    mPUSHn(upper_ci);
#line 1035 "CaseResampling.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Statistics__CaseResampling_approx_erf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_approx_erf)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	double	x = (double)SvNV(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 412 "CaseResampling.xs"
    RETVAL = cs_approx_erf(x);
#line 1055 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_approx_erf_inv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_approx_erf_inv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	double	x = (double)SvNV(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 420 "CaseResampling.xs"
    if (x <= 0. || x >= 1.)
      croak("The inverse error function is defined in (0,1). %f is outside that range", x);
    RETVAL = cs_approx_erf_inv(x);
#line 1078 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_alpha_to_nsigma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_alpha_to_nsigma)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	double	x = (double)SvNV(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 430 "CaseResampling.xs"
    RETVAL = cs_alpha_to_nsigma(x);
#line 1099 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Statistics__CaseResampling_nsigma_to_alpha); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Statistics__CaseResampling_nsigma_to_alpha)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	double	x = (double)SvNV(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 438 "CaseResampling.xs"
    RETVAL = cs_nsigma_to_alpha(x);
#line 1120 "CaseResampling.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Statistics__CaseResampling); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Statistics__CaseResampling)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Statistics::CaseResampling::RdGen::setup", XS_Statistics__CaseResampling__RdGen_setup);
        newXS_deffile("Statistics::CaseResampling::RdGen::setup_array", XS_Statistics__CaseResampling__RdGen_setup_array);
        newXS_deffile("Statistics::CaseResampling::RdGen::DESTROY", XS_Statistics__CaseResampling__RdGen_DESTROY);
        newXS_deffile("Statistics::CaseResampling::RdGen::genrand", XS_Statistics__CaseResampling__RdGen_genrand);
        newXS_deffile("Statistics::CaseResampling::resample", XS_Statistics__CaseResampling_resample);
        newXS_deffile("Statistics::CaseResampling::resample_medians", XS_Statistics__CaseResampling_resample_medians);
        newXS_deffile("Statistics::CaseResampling::resample_means", XS_Statistics__CaseResampling_resample_means);
        newXS_deffile("Statistics::CaseResampling::median", XS_Statistics__CaseResampling_median);
        newXS_deffile("Statistics::CaseResampling::median_absolute_deviation", XS_Statistics__CaseResampling_median_absolute_deviation);
        newXS_deffile("Statistics::CaseResampling::first_quartile", XS_Statistics__CaseResampling_first_quartile);
        newXS_deffile("Statistics::CaseResampling::third_quartile", XS_Statistics__CaseResampling_third_quartile);
        newXS_deffile("Statistics::CaseResampling::mean", XS_Statistics__CaseResampling_mean);
        newXS_deffile("Statistics::CaseResampling::sample_standard_deviation", XS_Statistics__CaseResampling_sample_standard_deviation);
        newXS_deffile("Statistics::CaseResampling::population_standard_deviation", XS_Statistics__CaseResampling_population_standard_deviation);
        newXS_deffile("Statistics::CaseResampling::select_kth", XS_Statistics__CaseResampling_select_kth);
        newXS_deffile("Statistics::CaseResampling::median_simple_confidence_limits", XS_Statistics__CaseResampling_median_simple_confidence_limits);
        newXS_deffile("Statistics::CaseResampling::simple_confidence_limits_from_samples", XS_Statistics__CaseResampling_simple_confidence_limits_from_samples);
        newXS_deffile("Statistics::CaseResampling::approx_erf", XS_Statistics__CaseResampling_approx_erf);
        newXS_deffile("Statistics::CaseResampling::approx_erf_inv", XS_Statistics__CaseResampling_approx_erf_inv);
        newXS_deffile("Statistics::CaseResampling::alpha_to_nsigma", XS_Statistics__CaseResampling_alpha_to_nsigma);
        newXS_deffile("Statistics::CaseResampling::nsigma_to_alpha", XS_Statistics__CaseResampling_nsigma_to_alpha);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
